// S3

//////////////////////////////////////// main function /////////////////////////////////////
// use MultiPwms Lib v.0.9. gpio parking is changed to GPIO3.
// use "ESP-07"
// 2021.02.21.

// configuration/used:
// IDE: generic ESP8266 module, 115200bps, 160MHz, 26MHz crystal, 1MB flash/80MHz
// pins: GND/TX/RX
// pins: Open/GPIO0/Pull-low
// pins: GND/speed signal with 10K resistor to input half voltage(to level shifter)
// raw speed signal > 15V, duty-cycle=90, freq==2xrpm.
// GPIO13, speed signal input from level shifter output/3.3v. capable of max sensing 5kHz signal.
// GPIO12, buzzer, max 1kHz base.
// GPIO14, control relay to bypass or disable AC.
// GPIO16, control AC on/off when AC was disabled.
// connector: power
// connector: USB jack. left to right are bypass high-side, bypass low-side and pull-it-high12v, raw speed signal, gnd.
// level shifter, max +-15v to 3.3v.
// 3 ss8050 used: control relay on, buzzer and GPIO16 sink.
// power board: 3.3V. max input source 24V
// GPIO5, (20210222 added). input, once AC-disabled, gen output pwm dc10% with the vpp1v and the freq the same as speed.

// 2021.02.22. update.
// 1. change /speed to /s for speedup.


//------this not yet
// 2. disable 2000, 3000 rpm alert. 4000 1 beep, 5000 2 beeps, 5800 a long beep, over 6300 a continuing long beep,
// error a continuing short beep.


// 3. rewrite smps. method;
// narrow down the valid rpm range(do the slop consideration) since noise much. suppose 5800rpm/s(joke, modify if not ok).
// the current old smps. is 50us. so, (10e6/(5800/60*2))*10%dc=517us/rev at least(a minimum v-level).
// two i figured out to improve. decrease smps. or vote decision.
// i chose both.
// if a 3 votes to dicide a voltage level however vote may across ideal v-level transition rather than filter noise where cause latency.
// so proper sampling rate is needed; twice the vote consecutively in order to catch the level which means 6 times sampling upon a level.
// voted was discarded. 517us/6=86us; suppose 2 vote results to guarantee no v-level missing. same v-level recur to get the period.
// also, it assumes the noises are < 86us which also shows larger smps more noises avoided.
// 4. fill some holes.

// 2021.04.05. update.
// 1. rearranged. add auto save/load parameters functions. and a lot others. (1M, FS256k, OTA374k). now almost fulfilled.
// version 0.1:
#define VERSION_20210405_0_1 "[[202104050001][AP][ESP_TESTAP:87654321][esp8266-iot:80][esp8266-iot-internet][upd:a.bin]"\
            "[MDNS:FIXED][ESP07][115200:160:26:1M:256KFS:404656SK:80M]]" // so the version number is the 3rd byte, length 12.
// 2021.04.06. update.
// 1. rearranged. minor update. (1M, FS256k, OTA374k). now almost fulfilled.
// version 0.2:
#define VERSION_202104050002 "[[202104050002][AP][ESP_TESTAP:87654321][esp8266-iot:80][esp8266-iot-internet][upd:a.bin]"\
            "[MDNS:FIXED][ESP07][115200:160:26:1M:256KFS:405136SK:80M]]" // so the version number is the 3rd byte, length 12.




// the following lines is supposed(optional) to replace a single line in sketch, the #include"Esp8266MyWiFiUnified.h".
// For the following macros copied to main for easy modify. So, copy these to there and uncomment it could simply done.
#ifndef _ESP8266_MY_WIFI_UNIFIED_DISABLEH_
#define _ESP8266_MY_WIFI_UNIFIED_DISABLEH_
#include <ESP8266WiFi.h>

////////////////// paste the macros here (which is between IoT BEGIN/END .h) //////////////////
// ************************** IoT BEGIN .h ******************************
// ========================== Options and Defs/modify if need ==============================
// -------------------------- for AP or STA ------------------------------
// 1 for ap, 0 for sta.
#define AP_MODE 1
#define STA_MODE (!AP_MODE)

// -------------------------- for ap/sta credential ------------------------------ comment it and put it in .cpp
#if 1
const char *const WIFI_CRED[][2]={
    {"ESP_TESTAP", "87654321"},
    {"Office", "123456"},
    {"Xperia X Performance_bc10", "e848acbcfd98"},
};
#endif // if 1

// -------------------------- for part of hostname ------------------------------
#define LSERVICE_1 "iot"
#define LPSERVICE_1 80

// -------------------------- for default connection names ------------------------------
// i.e., http://hostname.local/
#define HOSTNAME_BASE "esp8266" // for local used.
#define HOSTNAME ((String(HOSTNAME_BASE)+"-"+LSERVICE_1).c_str()) // for local used.
#define REMOTE_HOSTNAME "esp8266-iot-internet" // for remote use.

#define UPDFILE "a.bin" // the remote webpage for updating to local is http://REMOTE_HOSTNAME.local/upd

// -------------------------- other settings ------------------------------
#define HTTPC_GET_DELAY delay(5) // do the delay after an HTTP GET.
#define HTTPC_GET_PROC_DELAY delay(5) // do some delay during an HTTP GET course.
#define HTTPC_CONN_TIMEOUT 4000 // the timeout during a GET, 4000ms.

// all the TMO values is restricted to no more than 35 minutes; see the Timeout() for detail. however,
// cascading could overcome.
#define TMO_IOT_LOOP_PERIOD 30 // IoT polling at each 30ms
#define TMO_AP_C_CONN_PERIOD 180000 // each 180 seconds to show connections by AP
#define TMO_STA_CONN_HEALTH_PERIOD 20000 // each 20 seconds to check the connection health by STA(while ping is alive)
#define TMO_WEB_UPDATE_PERIOD (1000*60*30) // each 30 minutes to find internet update; if cascade twice(no, use count) will become 15hr
#define TMO_MDNS_Q_PERIOD 600000 // each 600 seconds to query services
#define TMO_PING_PERIOD 3000 // each 3 seconds to ping AP when ping failed

#define STA_RECOVER_ALIVE 0 // set 0 if STA connection broken and do not reconnect. 1 to reconnect.

// [mDns] use either of one
#define USE_MDNS_STANDALONE // no auto hostname
//#define USE_MDNS_FULL // auto hostname and query

// [STAtion] use either of one
//#define USE_STA_NATIVE // single AP
#define USE_STA_WIFI_MULTI // multiple APs(o)

// [HTTPClient] use either of one
//#define USE_HTTPC_HTTP_CLIENT
//#define USE_HTTPC_WIFI_CLIENT
#define USE_HTTPC_WIFIHTTP_HYBRID // (o2)
//#define USE_HTTPC_WIFIHTTP_HYBRID_NONBLOCKING // (o1)

// -------------------------- for mdns ------------------------------
typedef struct smDnsRecord{
    const char *service;
    const unsigned port;
} smDnsRecord;

// -------------------------- for mdns services ------------------------------ comment it and put it in .cpp
#if 1
#if defined(USE_MDNS_FULL)
const smDnsRecord mdns_ss[]={ // the services this device provides; note, at least the LSERVICE_1 has already provided.
    {"iot", 80},
    {"motor", 8080},
};
#endif // USE_MDNS_FULL

const smDnsRecord mdns_sskn[]={ // the known services this device needs from other devices.
    {"iot", 80},
    {"motor", 8080},
};
#endif // if 1
// ************************** IoT END .h ******************************
////////////////// paste the macros here (which is between IoT BEGIN/END .h) //////////////////

#include"Esp8266MyWiFiUnified.h"
#endif // _ESP8266_MY_WIFI_UNIFIED_DISABLEH_


#include"Esp8266MultiPwms.h"
#include"Esp8266Vars2File.h"




void my_http_request(){;}

void my_setup_http_server(){

    uri_list+=\
        "/version\r\n"\
        "/ls\r\n"\
        "/del?filename=<name>\r\n"\
        "/cp?src=<src_filename>&dst=<dst_filename>\r\n"\
        "/reset\r\n"\
        "/buzzer/delay?ival=<indec_val>\r\n"\
        "/relay/on\r\n"\
        "/relay/off\r\n"\
        "/ac/on\r\n"\
        "/ac/off\r\n"\
        "/ispeed/error\r\n"\
        "/ispeed/alert\r\n"\
        "/test/alert\r\n"\
        "/s\r\n";

    extern String theSpeedStr;
    server_p->on("/s", []() { // the speed value report
        server_p->send(200, "text/plain", theSpeedStr.c_str());
    });

    server_p->on("/version", []() { // show version
        server_p->send(200, "text/plain", VERSION_202104050002);
    });

    server_p->on("/ls", []() { // list directory
        String str="";
        cDataBase::Ls("/", &str);
        server_p->send(200, "text/plain", str.c_str());
    });

    server_p->on("/del", []() { // to delete the specified file.
        String fn=server_p->arg("filename");
        if (fn=="") server_p->send(404, "text/plain", "0. page not found.");
        else {
            if (cDataBase((String("/")+fn).c_str()).Remove())
                server_p->send(200, "text/plain", (String("1. removed: ")+fn).c_str());
            else server_p->send(404, "text/plain", "0. file not found.");
        }
    });

    server_p->on("/cp", []() { // to copy files.
        String src=server_p->arg("src");
        String dst=server_p->arg("dst");
        if (src=="") server_p->send(404, "text/plain", "0. page not found.");
        else if (dst=="") server_p->send(404, "text/plain", "0. page not found.");
        else {
            src="/"+src;
            dst="/"+dst;
            cDataBase::Cp(src.c_str(), dst.c_str());
            server_p->send(200, "text/plain", "1. copied.");
        }
    });

    server_p->on("/reset", []() { // reset and format the filesystem
        server_p->send(200, "text/plain", "now reset...");

        // ---------- format the fs
        cDataBase::Format();

        delay(1);
        while (1);
    });

    extern unsigned ictrl_buzzer_delay_ms;
    server_p->on("/buzzer/delay", []() { // to increase/dec the delay to buzzer sound. parameter: ival, incremental/dec.
        String sval=server_p->arg("ival");
        if (sval=="") server_p->send(404, "text/plain", "0. page not found, ival.");
        else {
            int ival=sval.toInt();
            if (int(ictrl_buzzer_delay_ms)+ival<=0) ictrl_buzzer_delay_ms=0;
            else ictrl_buzzer_delay_ms+=ival;
            server_p->send(200, "text/plain", (String("1. accepted: ")+ictrl_buzzer_delay_ms).c_str());

            // -----------write to settings file, auto create new if not exist
            cDataBase("/settings").ReplaceWordsEx(
                "ictrl_buzzer_delay_ms",
                0,
                ictrl_buzzer_delay_ms
            );
        }
    });

    server_p->on("/relay/on", []() { // to take over the control on AC
        server_p->send(200, "text/plain", "relay is now on");
        onRelay();
        beepON();
        // -----------write to settings file, auto create new if not exist
        extern unsigned is_ac_relay_on;
        cDataBase("/settings").ReplaceWordsEx(
            "is_ac_relay_on",
            0,
            is_ac_relay_on
        );
    });

    server_p->on("/relay/off", []() { // to release the control on AC
        server_p->send(200, "text/plain", "relay is now off");
        offRelay();
        beepOFF();
        // -----------write to settings file, auto create new if not exist
        extern unsigned is_ac_relay_on;
        cDataBase("/settings").ReplaceWordsEx(
            "is_ac_relay_on",
            0,
            is_ac_relay_on
        );
    });

    server_p->on("/ac/on", []() { // to turn on the AC
        server_p->send(200, "text/plain", "ac is now on");
        onAc();
        beepON();
    });

    server_p->on("/ac/off", []() { // to turn off the AC
        server_p->send(200, "text/plain", "ac is now off");
        offAc();
        beepOFF();
    });

    extern unsigned period5_err;
    server_p->on("/ispeed/error", []() { // to see the error count. clear count when seen.
        server_p->send(200, "text/plain", (String("error count ")+period5_err).c_str());
        period5_err=0;
    });

    extern unsigned speed_alert_flag;
    server_p->on("/ispeed/alert", []() { // alternatively turn on/off the speed alert
        speed_alert_flag^=1;
        if (speed_alert_flag){
            server_p->send(200, "text/plain", "speed alert on");
            beepON();
        }
        else {
            server_p->send(200, "text/plain", "speed alert off");
            beepOFF();
        }
        // -----------write to settings file, auto create new if not exist
        cDataBase("/settings").ReplaceWordsEx(
            "speed_alert_flag",
            0,
            speed_alert_flag
        );
    });

    extern unsigned test_alert_flag;
    server_p->on("/test/alert", []() { // alternatively turn on/off the buzzer test
        test_alert_flag^=1;
        if (test_alert_flag){
            server_p->send(200, "text/plain", "test alert on");
            beepON();
        }
        else {
            server_p->send(200, "text/plain", "test alert off");
            beepOFF();
        }
    });

}




String theSpeedStr="0"; // for speed value output to webpage.
unsigned speed_alert_flag=0; // to enable/disable speed alert sound.
unsigned test_alert_flag=0; // to enable/disable buzzer sound test.
unsigned period5_err=0; // to probe speed sensing error count.
extern unsigned is_ac_relay_on; // to turn on/off the relay for controlling the AC by this device.
extern unsigned AC_on_off_flag; // the flag that AC sould be on/1 or off/0
unsigned ictrl_buzzer_delay_ms=0; // for webpage control on the buzzer delay

#define NEW_PARKING_GPIO 3
#define LED_GPIO 2

void LedOn(){digitalWrite(LED_GPIO, LOW);}
void LedOff(){digitalWrite(LED_GPIO, HIGH);}




// ---------------------------------------AC Conditioner
cMultiPwms pwm_ac(5, 100000, 10, 0, 0); // GPIO5 for ac conditioner cheat
unsigned is_ac_relay_on=0; // to turn on/off the relay for controlling the AC by this device.
unsigned AC_on_off_flag=0; // the flag that AC sould be on/1 or off/0
unsigned AC_on_off_state=0; // the real state on/off of the AC
unsigned AC_on_off_switch=0; // the controlling switch to turn AC on/off. set 2 in already set state.

void setAcPwm(){ // according to the speed signal to set the freq signal to cheat AC.
    extern unsigned freq5;
    unsigned pr=1000000.0f/(freq5/60.0f+1.0f);
    pr=pr+200-pr%200;
    pwm_ac.setPeriod(pr, 10, 0, 1);
    pwm_ac.Resume();
}

void pauseAcPwm(){
    pwm_ac.Pause();
}

void onRelay(){is_ac_relay_on=1; digitalWrite(14, HIGH);}
void offRelay(){
    AC_on_off_switch=0;
    AcControlPolling();
    is_ac_relay_on=0;
    AC_on_off_flag=0;
    digitalWrite(14, LOW);
}
void onCheatAc(){pinMode(5, OUTPUT);}
void offCheatAc(){pinMode(5, INPUT); pauseAcPwm();}
void onAc(){AC_on_off_flag=1; digitalWrite(16, HIGH);}
void offAc(){AC_on_off_flag=0; digitalWrite(16, LOW);}

void AcControlPolling(){
    extern unsigned freq5;
    if (is_ac_relay_on){
        if (AC_on_off_switch!=2){
            if (AC_on_off_switch){
                onAc();
                offCheatAc();
                AC_on_off_state=1;
                AC_on_off_switch=2;
            }
            else {
                offAc();
                onCheatAc();
                AC_on_off_state=0;
                AC_on_off_switch=2;
            }
        }
        if (freq5){
            if (AC_on_off_state);
            else if (AC_on_off_flag) AC_on_off_switch=1;
            else if (freq5<5000) setAcPwm(); // when control enabled and 0<freq<5000 will do the cheat
        }
        else if (AC_on_off_state) AC_on_off_switch=0;
    }
}




// -------------------------------------------- pwm buzzer
cMultiPwms pwm_buzzer(12, 1000, 20, 0, 0); // GPIO12

struct sPwmSound{ // if delay_ms==0, means pause, uses lower_bound for pause-ms.
    int lower_bound;
    int upper_bound;
    int inc;
    unsigned delay_ms;
};

sPwmSound buzzer_melody1[]={

    // (pos=0, size=3), single beep.
    {1000, 1000, 0, 20},
    {1800, 1800, 0, 5},
    {600, 600, 0, 30},

    // (0, 7), 2 beeps.
    {3, 0, 0, 0},
    {1000, 1000, 0, 20},
    {1800, 1800, 0, 5},
    {600, 600, 0, 30},

    // (0, 11), 3 beeps.
    {6, 0, 0, 0},
    {1000, 1000, 0, 20},
    {1800, 1800, 0, 5},
    {600, 600, 0, 30},

    // (0, 15), 4 beeps.
    {4, 0, 0, 0},
    {1000, 1000, 0, 20},
    {1800, 1800, 0, 5},
    {600, 600, 0, 30},

    // (0, 19), 5 beeps.
    {7, 0, 0, 0},
    {1000, 1000, 0, 20},
    {1800, 1800, 0, 5},
    {600, 600, 0, 30},

    // (19, 1), single lasting 1.5 second beep.
    {600, 600, 0, 1500},

    // (20, 29), short continuing 15 beeps.
    {400, 400, 0, 30},
    {95, 0, 0, 0},
    {400, 400, 0, 40},
    {60, 0, 0, 0},
    {400, 400, 0, 50},
    {80, 0, 0, 0},
    {400, 400, 0, 40},
    {50, 0, 0, 0},
    {400, 400, 0, 30},

    {120, 0, 0, 0},

    {400, 400, 0, 30},
    {95, 0, 0, 0},
    {400, 400, 0, 40},
    {60, 0, 0, 0},
    {400, 400, 0, 50},
    {80, 0, 0, 0},
    {400, 400, 0, 40},
    {50, 0, 0, 0},
    {400, 400, 0, 30},

    {120, 0, 0, 0},

    {400, 400, 0, 30},
    {95, 0, 0, 0},
    {400, 400, 0, 40},
    {60, 0, 0, 0},
    {400, 400, 0, 50},
    {80, 0, 0, 0},
    {400, 400, 0, 40},
    {50, 0, 0, 0},
    {400, 400, 0, 30},

    // (49, 5), for "on" sound.
    {3000, 3000, 0, 15},
    {800, 800, 0, 40},
    {3000, 3000, 0, 80},
    {15, 0, 0, 0},
    {2000, 2000, 0, 30},

    // (54, 5), for "off" sound.
    {2000, 2000, 0, 30},
    {15, 0, 0, 0},
    {3000, 3000, 0, 15},
    {800, 800, 0, 40},
    {3000, 3000, 0, 80},

    // (59, 6), mid gi gi gi.
    {80, 0, 0, 0},
    {800, 800, 0, 2},
    {4, 0, 0, 0},
    {800, 800, 0, 2},
    {4, 0, 0, 0},
    {800, 800, 0, 2},

    // (65, 6), low gi gi gi.
    {80, 0, 0, 0},
    {9000, 9000, 0, 2},
    {4, 0, 0, 0},
    {9000, 9000, 0, 2},
    {4, 0, 0, 0},
    {9000, 9000, 0, 2},

    // (71, 6), high gi gi gi.
    {80, 0, 0, 0},
    {200, 200, 0, 2},
    {4, 0, 0, 0},
    {200, 200, 0, 2},
    {4, 0, 0, 0},
    {200, 200, 0, 2},

#if 0 // it works well however, wifi-loop if enabled would affect the buzzer-loop. so, single tone could be ok.

    /*static unsigned tmo_sta=micros(), tt=0;
    if (cMultiPwms::Timeout(4000, tmo_sta)){
        if (tt==0) config_buzzer_sound(buzzer_melody1, 2); // 1
        else if (tt==1) config_buzzer_sound(buzzer_melody1, 5); // 2
        else if (tt==2) config_buzzer_sound(buzzer_melody1, 8); // 3
        else if (tt==3) config_buzzer_sound(buzzer_melody1, 11); // 4
        else if (tt==4) config_buzzer_sound(buzzer_melody1, 14); // 5
        else if (tt==5) config_buzzer_sound(buzzer_melody1+14, 1); // long beep
        else if (tt==6) config_buzzer_sound(buzzer_melody1+15, 29); // beep beep ...
        else if (tt==7) config_buzzer_sound(buzzer_melody1+44, 7); // on
        else if (tt==8) config_buzzer_sound(buzzer_melody1+51, 8); // off
        if (++tt>8) tt=0;
    }*/

    // (pos=0, size=2), single beep.
    {4000, 200, -200, 6},
    {6000, 400, -200, 2},

    // (0, 5), 2 beeps.
    {3, 0, 0, 0},
    {3000, 400, -200, 6},
    {7000, 200, -200, 2},

    // (0, 8), 3 beeps.
    {6, 0, 0, 0},
    {4000, 200, -200, 6},
    {6000, 400, -200, 2},

    // (0, 11), 4 beeps.
    {4, 0, 0, 0},
    {3000, 400, -200, 6},
    {7000, 200, -200, 2},

    // (0, 14), 5 beeps.
    {7, 0, 0, 0},
    {4000, 200, -200, 6},
    {6000, 400, -200, 2},

    // (14, 1), single lasting 1.5 second beep.
    {500, 500, 0, 1500},

    // (15, 29), short continuing 15 beeps.
    {400, 400, 0, 30},
    {95, 0, 0, 0},
    {400, 400, 0, 40},
    {60, 0, 0, 0},
    {400, 400, 0, 50},
    {80, 0, 0, 0},
    {400, 400, 0, 40},
    {50, 0, 0, 0},
    {400, 400, 0, 30},

    {120, 0, 0, 0},

    {400, 400, 0, 30},
    {95, 0, 0, 0},
    {400, 400, 0, 40},
    {60, 0, 0, 0},
    {400, 400, 0, 50},
    {80, 0, 0, 0},
    {400, 400, 0, 40},
    {50, 0, 0, 0},
    {400, 400, 0, 30},

    {120, 0, 0, 0},

    {400, 400, 0, 30},
    {95, 0, 0, 0},
    {400, 400, 0, 40},
    {60, 0, 0, 0},
    {400, 400, 0, 50},
    {80, 0, 0, 0},
    {400, 400, 0, 40},
    {50, 0, 0, 0},
    {400, 400, 0, 30},

    // (44, 7), for "on" sound.
    {1000, 4000, 200, 10},
    {4000, 4000, 0, 200},
    {2000, 2000, 0, 50},
    {2000, 200, -200, 2},
    {200, 200, 0, 50},
    {2000, 2000, 0, 50},
    {2000, 200, -200, 4},

    // (51, 8), for "off" sound.
    {2000, 200, -200, 2},
    {200, 200, 0, 50},
    {2000, 2000, 0, 50},
    {2000, 200, -200, 4},
    {1000, 4000, 200, 10},
    {4000, 4000, 0, 200},
    {100, 0, 0, 0},
    {4000, 4000, 0, 200},
#endif
};

unsigned buzzer_issued1=0, buzzer_melody_sz1=0;
const sPwmSound *buzzer_melody_ptr=0;

void buzzer_sound(const struct sPwmSound *buzzer_melody, const unsigned buzzer_melody_sz, unsigned &buzzer_issued){ // only for 1 instance.
    static int x;
    static unsigned x_sz, current_time;
    switch (buzzer_issued){
        case 0: return;
        case 1:
            x_sz=0;
            buzzer_issued=2;
        case 2:
            if (++x_sz>buzzer_melody_sz){buzzer_issued=0; pwm_buzzer.Pause(); LedOff(); return;}
            x=buzzer_melody[x_sz-1].lower_bound;
            if (!buzzer_melody[x_sz-1].delay_ms){
                pwm_buzzer.Pause();
                current_time=micros();
                buzzer_issued=5;
                return;
            }
            buzzer_issued=3;
        case 3:
            if (buzzer_melody[x_sz-1].inc>0 && x>buzzer_melody[x_sz-1].upper_bound){buzzer_issued=2; return;}
            else if (buzzer_melody[x_sz-1].inc<0 && x<buzzer_melody[x_sz-1].upper_bound){buzzer_issued=2; return;}
            current_time=micros();
            pwm_buzzer.setPeriod(x, 2, 50);
            pwm_buzzer.Resume();
            LedOn();
            buzzer_issued=4;
        case 4:
            if (!cMultiPwms::Timeout(buzzer_melody[x_sz-1].delay_ms, current_time, true, true)) return;

            // for webpage control
            extern unsigned ictrl_buzzer_delay_ms;
            static unsigned tmoi=micros();
            if (!cMultiPwms::Timeout(ictrl_buzzer_delay_ms, tmoi, true, true)) return;
            else tmoi=micros();

            if (buzzer_melody[x_sz-1].inc) x+=buzzer_melody[x_sz-1].inc;
            else {buzzer_issued=2; return;}
            buzzer_issued=3;
            return;
        case 5:
            if (!cMultiPwms::Timeout(x, current_time, true, true)) return;
            buzzer_issued=2;
            return;
        default: buzzer_issued=0; pwm_buzzer.Pause(); return;
    }
}

void config_buzzer_sound(const struct sPwmSound *ptr, const unsigned sz){
    buzzer_melody_ptr=ptr;
    buzzer_melody_sz1=sz;
    buzzer_issued1=1;
}

void poll_buzzer_sound(){
    if (buzzer_melody_ptr) buzzer_sound(buzzer_melody_ptr, buzzer_melody_sz1, buzzer_issued1);
}

void beepON(){config_buzzer_sound(buzzer_melody1+49, 5);}
void beepOFF(){config_buzzer_sound(buzzer_melody1+54, 5);}
void beepBEEP(){config_buzzer_sound(buzzer_melody1+20, 29);}




// ------------------------------------ to probe speed signal freq
#define P5S_PERIOD 86
cHwTimer timer_prob_freq(P5S_PERIOD, isr_prob_freq);

#if 1 // new version
unsigned freq5=0;
IRAM_ATTR unsigned pre_state5=0, period5=0, p5smps[3]={0, 0, 0}, p5cnt=0, repeated_state5=0;
IRAM_ATTR void isr_prob_freq(){
    unsigned cur_state5;
    p5smps[p5cnt++]=((micros()&0xFFFFFFFE)|!digitalRead(13));
    if (p5cnt>2){
        p5cnt=0;
        if ((p5smps[0]^p5smps[1])&0x1) cur_state5=p5smps[2]-(P5S_PERIOD&0xFFFFFFFE); // at most a period lost.
        else cur_state5=p5smps[0];

        ///// this may be wrong since the vote may be wrong while across the level transition causing wrong data refreshed into.
        /////if ((pre_state5^cur_state5)&0x1){
        /////    if (cur_state5&0x1) period5=cur_state5-pre_state5;
        /////    pre_state5=cur_state5;
        /////}
        ///// so, we need 2 results to confirm. (Note: such the wrong is as to be twice. we might simply fix it by dividing 2.)
        if ((pre_state5^cur_state5)&0x1){/////
            if (repeated_state5){ // the 2nd result. // possible wrong at every 76min if got 0 and level0.
                if (cur_state5&0x1){
                    period5=repeated_state5-pre_state5;
                    pre_state5=repeated_state5;
                }
                else pre_state5&=0xFFFFFFFE;
                repeated_state5=0;
            }
            else repeated_state5=cur_state5; // the 1st result.
        }
        else repeated_state5=0;
    }
}
#else // old version
unsigned freq5=0;
IRAM_ATTR unsigned pre_state5=0, cur_state5=0, tmcnt5=0, period5=0;
IRAM_ATTR void isr_prob_freq(){
    cur_state5=!digitalRead(13);
    if (pre_state5^cur_state5){
        if (cur_state5){
            period5=micros()-tmcnt5;
            tmcnt5=micros();
        }
        pre_state5=cur_state5;
    }
}
#endif

void speed_average(){
    // here prevent from freeze which may cause big trouble.
    // it tooks a big cost though.
    static unsigned tmo_fz=micros(), fz=period5;
    if (period5 && (fz==period5)){
        if (cMultiPwms::Timeout(10000, tmo_fz, true)) fz=period5=0;
    }
    else {fz=period5; tmo_fz=micros();}

    static unsigned older=0, oldest=0, i=0;
    if (period5>100 && period5<1000000){
        if (period5<=4580){period5=4285; freq5=7001; period5_err++; return;} // probe the errors //////////////////////////
        oldest=older;
        older=freq5;
        freq5=(((30000000/period5)*8+older*5+oldest*3)>>4);
        i=0;
    }
    else if (i++>5){oldest=older=freq5=i=0;}
}

void speed_alert(){
    // if want to continue alert at a specific stage, set its falling as the next rising stage (A+1).
    const unsigned rising[]=    {0, 999, 1999, 2999, 3999, 4999, 5799, 6299, 6999, 7499, 7999, unsigned(-1)};
    const unsigned falling[]=   {0, 750, 1750, 2750, 3750, 4750, 5550, 7000, 7500, 8000, unsigned(-1)};
    const int snd_offset[]=     {-1, -1, 0,    0,    0,    0,    19,   19,   59,   65,   71}; // -1 desig not use.
    const int snd_size[]=       {-1, -1, 7,    11,   15,   19,   1,    1,    6,    6,    6};
    static unsigned pivot=0;
    unsigned i=pivot;

    while (freq5>rising[i+1]) i++;
    if ((pivot<i) && (snd_offset[i]>=0)){
        if (!buzzer_issued1) config_buzzer_sound(buzzer_melody1+snd_offset[i], snd_size[i]);
    }
    while (freq5<falling[i]) i--;
    pivot=i;
}




// --------------------------------- the main funcs ---------------------------------
void init_params(){
    cDataBase s("/settings");
    s.Open();
    unsigned char buff[128];
    unsigned str_sz=0, BootTimes=0;

    if (str_sz=s.ReadData(buff, 127, "ManualUpdWebsite", 0)){
        buff[str_sz]=0;
        new_webupd_website=(char*)buff;
        printf("load update website success: %s\r\n", new_webupd_website.c_str());
    }
    if (s.ReadWords(ictrl_buzzer_delay_ms, "ictrl_buzzer_delay_ms", 0)){
        printf("load params success: %s %u\r\n", "ictrl_buzzer_delay_ms", ictrl_buzzer_delay_ms);
    }
    if (s.ReadWords(is_ac_relay_on, "is_ac_relay_on", 0)){
        printf("load params success: %s %u\r\n", "is_ac_relay_on", is_ac_relay_on);
    }
    if (s.ReadWords(speed_alert_flag, "speed_alert_flag", 0)){
        printf("load params success: %s %u\r\n", "speed_alert_flag", speed_alert_flag);
    }
    if (s.ReadWords(BootTimes, "BootTimes", 0)){
        printf("load params success: %s %u\r\n", "BootTimes", BootTimes);
    }
    s.Close();
    s.ReplaceWordsEx("BootTimes", 0, ++BootTimes);
    if (!(BootTimes%5)) s.Renew();
}

void setup_cmultipwms() {
    //ADC_MODE(ADC_TOUT);

    pinMode(NEW_PARKING_GPIO, INPUT); // by the RX0. set it as the parking pin.

    pinMode(LED_GPIO, OUTPUT); // led

    pinMode(13, INPUT); // speed
    pinMode(12, OUTPUT); digitalWrite(12, LOW); // buzzer
    pinMode(14, OUTPUT); digitalWrite(14, LOW); // relay
    pinMode(16, OUTPUT); digitalWrite(16, LOW); // ac
    pinMode(5, INPUT); // to cheat the AC conditioner.
}

void setup(){
    setup_cmultipwms();

    Serial.begin(115200);
    delay(5000);

    init_params();

    randomSeed(micros()%ESP.getChipId());
    setup_IoT();

    pwm_buzzer.setDC(5);
    ////pwm_buzzer.Resume();////timer not bring up issue.
    pwm_buzzer.Pause();
    beepBEEP();
}

void loop(){
    loop_IoT();
    speed_average();
    theSpeedStr=freq5;
    if (speed_alert_flag) speed_alert();
    poll_buzzer_sound();
    AcControlPolling();

    // after 5 minutes, disable mdns. so the clients have to remember and use ip.
    static unsigned tmo_stb=micros();
    if (mdns_enabled && cMultiPwms::Timeout(300000, tmo_stb, true, true)) mdns_enabled=false;

    // for buzzer sound test
    static unsigned tmo_sta=micros(), tt=0;
    if (test_alert_flag && cMultiPwms::Timeout(4000, tmo_sta)){
        if (tt==0) config_buzzer_sound(buzzer_melody1, 3); // 1
        else if (tt==1) config_buzzer_sound(buzzer_melody1, 7); // 2
        else if (tt==2) config_buzzer_sound(buzzer_melody1, 11); // 3
        else if (tt==3) config_buzzer_sound(buzzer_melody1, 15); // 4
        else if (tt==4) config_buzzer_sound(buzzer_melody1, 19); // 5
        else if (tt==5) config_buzzer_sound(buzzer_melody1+19, 1); // long beep
        else if (tt==6) config_buzzer_sound(buzzer_melody1+20, 29); // beep beep ...
        else if (tt==7) config_buzzer_sound(buzzer_melody1+49, 5); // on
        else if (tt==8) config_buzzer_sound(buzzer_melody1+54, 5); // off
        else if (tt==9) config_buzzer_sound(buzzer_melody1+59, 6); // mid gi gi gi
        else if (tt==10) config_buzzer_sound(buzzer_melody1+65, 6); // low gi gi gi
        else if (tt==11) config_buzzer_sound(buzzer_melody1+71, 6); // high gi gi gi
        if (++tt>11) tt=0;
    }
}
